# Concepts

## Overview

| name                                                                | description                                          |
| ------------------------------------------------------------------- | ---------------------------------------------------- |
| [chain()](chain.md)                                                 | Core funcchain syntax component to write chains      |
| [Input Args](input.md)                                              | prompt placeholders and input for your chains        |
| [BaseModel](pydantic.md)                                            | Core component to create pydantic models/classes     |
| [Settings](../getting-started/config.md#set-global-settings)        | Global settings object with for all your chains      |
| [SettingsOverride](../getting-started/config.md#set-local-settings) | Local settings dict for a specific chain             |
| [OutputParser](parser.md)                                           | Parses the llm output into your desired shape        |
| [Prompting](prompting.md)                                           | Templating system and techniques for writing prompts |
| [Vision](vision.md)                                                 | LLM that can also takes images as input/context      |
| [Streaming](streaming.md)                                           | Token by token streaming of llm output               |
| [Unions](unions.md)                                                 | Pydantic union types for your models                 |
| [LangChain](langchain.md)                                           | Library for building cognitive systems               |
